       /****************************************************************\
      * *              Corps des fonctions de l'interface              * *
     *   **************************************************************   *
    *     *   @ Authors : C. Descombes, M. Marmol                    *     *
   *   *   *                                                        *   *   *
    *     *   @ Date    : 19/10/2006                                 *     *
     *   *                                                            *   *
      * *     @ File    : interface.cpp                                * *
       \****************************************************************/


#include <QtGui>

#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>

#include <windows.h>
#include <ShellApi.h>

#include "interface.h"

using namespace std;


bool IsModif = false;

//bool Saisies  = true;
//bool MiniMenu = true;
//bool Log 	  = true;


//ofstream ofile ("debug.txt");


Interface::Interface(QMainWindow *parent) : QMainWindow(parent)
{
    ui.setupUi(this);
    Nouveau();

//	string Str;
//	ifstream conf ("config.ini");
//
//	// Saisies
//	getline (conf, Str);
//	if (Str [Str.size() - 1] - '0' == 0) Log ("pas de saisies");
//
//	// MiniMenu
//	getline (conf, Str);
//	if (Str [Str.size() - 1] - '0' == 0)
//
//	// Log
//	getline (conf, Str);
//	if (Str [Str.size() - 1] - '0' == 0)

} // constructeur d'interface



void Interface::clearTab ()
{
	const int nbOnglets = ui.ongletsMatrices->count();
	if (nbOnglets > 1)
	{
		for (int i = 1; i < nbOnglets; ++i)
			ui.ongletsMatrices->removeTab (1);
		
		int nbLig = ui.Matrice->rowCount();
		int nbCol = ui.Matrice->columnCount();

		QTableWidgetItem *WhiteItem = new QTableWidgetItem();
		for (int i = 0; i < nbLig; ++i)
		for (int j = 0; j < nbCol; ++j)
			ui.Matrice->item(i, j)->setBackgroundColor (QColor(WhiteItem->backgroundColor()));
	}

} // clearTab ()



void Interface::labelTable ()
{
	int nbVar = ui.spinBox_Var->value();
	int nbCtr = ui.spinBox_Ctr->value();

	ostringstream olib;

    for (unsigned i (0); i < nbVar; ++i)
    {
        olib << 'X' << i + 1;
        ui.Matrice->setHorizontalHeaderItem
					(i, new QTableWidgetItem(olib.str().c_str()));
        olib.str ("");
    }

    for (unsigned i (0); i < nbCtr; ++i)
    {
        olib << 'e' << i + 1;
        ui.Matrice->setHorizontalHeaderItem 
					(i + nbVar, new QTableWidgetItem(olib.str().c_str()));
        olib.str ("");
    }

    for (unsigned i (0); i < nbCtr; ++i)
    {
        olib << 'e' << i + 1;
        ui.Matrice->setVerticalHeaderItem
					(i, new QTableWidgetItem(olib.str().c_str()));
        olib.str ("");
    }

	ui.Matrice->setVerticalHeaderItem 
				(nbCtr, new QTableWidgetItem("Coef."));

	ui.Matrice->setHorizontalHeaderItem 
				(nbCtr + nbVar, new QTableWidgetItem("2nd-Membre"));

} // labelTable ()



void Interface::redimTable (QTableWidget &M, int Size)
{
    for (int i = 0; i < M.columnCount(); ++i)
        M.setColumnWidth ( i , Size );

} // redimColonnes ()



QTableWidget * Interface::Transpose(QTableWidget &M)
{
	int nbLig = M.rowCount();
	int nbCol = M.columnCount();
	int nbVar = ui.spinBox_Var->value();
	int nbCtr = ui.spinBox_Ctr->value();

	int nbLigT = nbVar + 1;
	int nbColT = nbCol;
	int nbVarT = nbCtr;
	int nbCtrT = nbVar;


	QTableWidget *T = new QTableWidget();
	T->setColumnCount(nbColT);
	T->setRowCount	 (nbLigT);


	// Copie des valeurs
	for (int i = 0; i < nbCtr; ++i)
	for (int j = 0; j < nbVar; ++j)
    	T->setItem(j, i, new QTableWidgetItem (M.item(i,j)->text()));

	for (int i = 0; i < nbVar; ++i)
	for (int j = 0; j < nbVar; ++j)
	{
    	if (i == j)
			T->setItem( j, i + nbCtr, new QTableWidgetItem ("1"));
		else
			T->setItem( j, i + nbCtr, new QTableWidgetItem ("0"));
	}

	for (int i = 0; i < nbCtr; ++i)
		T->setItem(nbVar, i, new QTableWidgetItem (M.item(i,nbCol-1)->text()));

	for (int i = 0; i < nbVar; ++i)
		T->setItem(i, nbCol - 1, new QTableWidgetItem (M.item(nbLig - 1,i)->text()));

	for (int i = 0; i < nbVar; ++i)
		T->setItem(nbVar, i + nbCtr, new QTableWidgetItem ("0"));

	T->setItem(nbVar, nbCtr + nbVar, new QTableWidgetItem ("0"));


	//Copie des libells
	for (int i = 0; i < nbCtrT; ++i)
	{
		T->setVerticalHeaderItem (i, new QTableWidgetItem (M.horizontalHeaderItem(i)->text()));
		T->setHorizontalHeaderItem (i + nbVarT, new QTableWidgetItem (M.horizontalHeaderItem(i)->text()));
	}

	for (int i = 0; i < nbVarT; ++i)
		T->setHorizontalHeaderItem (i, new QTableWidgetItem (M.horizontalHeaderItem(i + nbVar)->text()));

	T->setVerticalHeaderItem 
				(nbCtrT, new QTableWidgetItem("Coef."));

	T->setHorizontalHeaderItem 
				(nbCtrT + nbVarT, new QTableWidgetItem("2nd-Membre"));

	return T;

} // Transpose ()



void Interface::copyTable (QTableWidget &Old, QTableWidget &New)
{
	int nbLig = Old.rowCount();
	int nbCol = Old.columnCount();

	New.clear();
    New.setColumnCount(nbCol);
    New.setRowCount(nbLig);

    redimTable(New);

	for (int i = 0; i < nbLig; ++i)
	for (int j = 0; j < nbCol; ++j)
	{
		QTableWidgetItem *__item = new QTableWidgetItem();
		__item->setTextAlignment (Qt::AlignHCenter | Qt::AlignVCenter);
		__item->setText(Old.item(i, j)->text());
    	New.setItem(i, j, __item);
	}

	for (int i = 0; i < nbLig; ++i)
		New.setVerticalHeaderItem (i, new QTableWidgetItem (Old.verticalHeaderItem(i)->text()));

	for (int i = 0; i < nbCol; ++i)
		New.setHorizontalHeaderItem (i, new QTableWidgetItem (Old.horizontalHeaderItem(i)->text()));

} // copyTable ()



void Interface::paintTable (QTableWidget &M, int Lig, int Col)
{
	int nbLig = M.rowCount();
	int nbCol = M.columnCount();

	for (int i = 0; i < nbLig; ++i)
		M.item(i, Col)->setBackgroundColor (QColor(0,255,0,20));

	for (int j = 0; j < nbCol; ++j)
		M.item(Lig, j)->setBackgroundColor (QColor(0,255,0,20));

} // paintTable ()



void Interface::Log (string Str, string Color)
{
	QTime time = QTime::currentTime();
	ostringstream ostr;
	ostr << time.toString().toStdString()
		 << " - <font color=" << Color << '>' << Str << "</font>"
		 << ui.textLog->toHtml().toStdString();
	ui.textLog->setHtml(ostr.str().c_str());

} // Log ()





///////////////////////////////
//                           //
//     FONCTIONS "PIVOT"     //
//                           //
///////////////////////////////


int Interface::getColPivot (QTableWidget &M)
{
    int    ColPivot = 0;
    double Res = 0;
    double Max = 0;

    for (int Col = 0; Col < M.columnCount()-1; ++Col)
    {
        Res = (*M.item( M.rowCount() - 1, Col )).text().toDouble();

        if (Res > Max)
		{
            Max = Res;
			ColPivot = Col;
		}
    }
    return ColPivot;

} // getColPivot ()




int Interface::getLigPivot (QTableWidget &M, int ColPivot)
{
    int LigPivot = 0;
    double Res = 0;
    double Min = 2000000000; // 2 milliards

    for (int Lig = 0; Lig < M.rowCount()-1; ++Lig)
    {
        if ((*M.item( Lig, ColPivot )).text().toDouble() > 0)
        {
            Res = (*M.item( Lig, M.columnCount()-1 )).text().toDouble() 
				/ (*M.item( Lig, ColPivot )).text().toDouble();

            if (Res < Min)
			{
            	Min = Res;
				LigPivot = Lig;
        	}
		}
    }
    return LigPivot;

} // getLigPivot ()


void Interface::Primal()
{
	int nbVar = ui.spinBox_Var->value();
	int nbCtr = ui.spinBox_Ctr->value();

	int nbLig = ui.Matrice->rowCount();
	int nbCol = ui.Matrice->columnCount();


	// On paint la matrice en blanc
	QTableWidgetItem *WhiteItem = new QTableWidgetItem();
	for (int i = 0; i < nbLig; ++i)
	for (int j = 0; j < nbCol; ++j)
		ui.Matrice->item(i, j)->setBackgroundColor (QColor(WhiteItem->backgroundColor()));


    // On cr un tableau d'indices de rsultats
    int LigRes [nbLig - 1];
    int ColRes [nbCol - 1];

    for (unsigned int i = 0; i < nbVar; ++i)
    {
        LigRes [i] = nbLig - 1;
        ColRes [i] = i;
    }
    
    for (unsigned int i = 0; i < nbCtr; ++i)
    {
        LigRes [i + nbVar] = i; 
        ColRes [i + nbVar] = nbCol - 1;
    }


	int    Col, Lig, ColPivot, LigPivot;
	double LigCol, LigPivotCol, LigColPivot;
    double NbPivot;
	double Item;

	bool   Sortie;

	ostringstream ostr, os;

	QTableWidget *NewMatrice = new QTableWidget();
	copyTable (*ui.Matrice, *NewMatrice);

	ColPivot = getColPivot (*NewMatrice);
	LigPivot = getLigPivot (*NewMatrice, ColPivot);
	NbPivot  = NewMatrice->item( LigPivot, ColPivot )->text().toDouble();


	int Et = 1;
    for ( ; ; ++Et)
    {
		QTableWidget *AffMatrice = new QTableWidget();

		if (Et > 1)
		{
			// On cr un nouvel onglet contenant la NewMatrice actuelle
			copyTable (*NewMatrice, *AffMatrice);
	
			QWidget *tab = new QWidget();
	    	QGridLayout *gridLayout = new QGridLayout(tab);
	
	    	gridLayout->addWidget(AffMatrice, 0, 0, 1, 1);
	
			os << "Etape " << Et - 1;
	
	    	ui.ongletsMatrices->addTab(tab, os.str().c_str());
			ui.ongletsMatrices->setTabText(ui.ongletsMatrices->indexOf(tab), os.str().c_str());
	
			os.str("");
	
	
			// On rcupre les nouveaux "pivots"
			ColPivot = getColPivot (*NewMatrice);
			LigPivot = getLigPivot (*NewMatrice, ColPivot);
	        NbPivot  = NewMatrice->item( LigPivot, ColPivot )->text().toDouble();

		}


        // Condition d'arrt : tous les coeff <= 0
        for (int i = 0; i < nbVar; ++i)
        {
			if (NewMatrice->item(nbLig-1, i)->text().toDouble())
			    Item = NewMatrice->item(nbLig-1, i)->text().toDouble();
			else
				Item = 0;

            if (Item > 0) 
            {
                Sortie = false;
                break;
            }
            Sortie = true;
        }
        if (Sortie) break;


		// On colorie la ligne pivot et la colonne pivot
		if (Et > 1) paintTable (*AffMatrice, LigPivot, ColPivot);
		else		paintTable (*ui.Matrice, LigPivot, ColPivot);


		// Le libell de LigPivot est remplac par celui de ColPivot
		NewMatrice->setVerticalHeaderItem
			(LigPivot, new QTableWidgetItem (NewMatrice->horizontalHeaderItem (ColPivot)->text()));


        // On remplit le tableau d'indices de rsultats
        LigRes [ColPivot] = LigPivot;
        ColRes [ColPivot] = nbCol - 1;
        LigRes [LigPivot + nbVar] = - 1;


		// Modifications des valeurs de NewMatrice
        for (Col = 0; Col < nbCol; ++Col)
        {
            // On ne traite pas la colonne pivot
            if (Col == ColPivot) continue;

            // Pour chaque ligne, on retire  la valeur le produit de ses 
            // correspondants sur LigPivot et ColPivot diviss par NbPivot
            for (Lig = 0; Lig < nbLig; ++Lig)
            {
                // On ne traite pas la ligne pivot
                if (Lig == LigPivot) continue;

				LigCol 		= (*NewMatrice->item( Lig, Col )).text().toDouble();
				LigPivotCol = (*NewMatrice->item( LigPivot, Col )).text().toDouble();
				LigColPivot = (*NewMatrice->item( Lig, ColPivot )).text().toDouble();

				os << LigCol - (LigPivotCol * LigColPivot) / NbPivot;
    			NewMatrice->setItem(Lig, Col, new QTableWidgetItem (os.str().c_str()));
				os.str("");
            }
        }


		// On divise la ligne pivot par le nombre pivot
        for (Col = 0; Col < nbCol; ++Col)
        {
			os << NewMatrice->item( LigPivot, Col )->text().toDouble() / NbPivot;
    		NewMatrice->setItem( LigPivot, Col, new QTableWidgetItem (os.str().c_str()));
			os.str("");
        }


        // On remplace les valeurs de ColPivot par 0 sauf pour LigPivot  
        for (Lig = 0; Lig < nbLig; ++Lig)
        {
            if (Lig == LigPivot) continue;

    		NewMatrice->setItem(Lig, ColPivot, new QTableWidgetItem ("0"));
        }


    } // Itrations



	if (Et != 1)
	{
	    ostr << "<b>Variables :</b><br>";
	
	    for (Col = 0; Col < nbCol - 1; ++Col)
	    {
	        // Affichage de Contraintes :
	        if ( Col == nbVar )
	            ostr << "<br><br><b>Contraintes :</b><br><br>";
	        else
	            ostr << "<br>";
	            
			ostr << ui.Matrice->horizontalHeaderItem(Col)->text().toStdString() << " = ";
			
	        // Affichage du rsultat
	        if (LigRes [Col] == -1)
	            ostr << 0;
	        else
	            ostr << NewMatrice->item( LigRes[Col], ColRes[Col] )->text().toDouble();
	
	    }
	
	    ostr << setprecision(15) << "<br><br><b> Z = " 
	         << - (NewMatrice->item( nbLig-1 , nbCol-1 )->text().toDouble()) << "<br><br>";
	
	
		ui.ongletsMatrices->setTabText(ui.ongletsMatrices->count() - 1, "Matrice finale");

		// Cration d'un nouvel onglet Rsultat
	    QWidget *tabF = new QWidget();
	    QGridLayout *gridLayout = new QGridLayout(tabF);
	
	    QTextEdit *text = new QTextEdit(tabF);
		text->setReadOnly(true);
    	text->setOverwriteMode(true);
	    gridLayout->addWidget(text, 0, 0, 1, 1);
	
	    ui.ongletsMatrices->addTab(tabF, "Tab Finale");
		ui.ongletsMatrices->setTabText(ui.ongletsMatrices->indexOf(tabF), "Rsultats");
		ui.ongletsMatrices->setCurrentIndex(ui.ongletsMatrices->count() - 1);
	
		text->setHtml (ostr.str().c_str());


		ostringstream olog;			
		olog << "Problme primal rsolu : Z = "
	         << - (NewMatrice->item( nbLig-1 , nbCol-1 )->text().toDouble());
		Log (olog.str(), "red");
		olog.str("");

	}
	else
		QMessageBox::information(ui.centralwidget, 
					tr("Bizarre..."),
					tr("<p align=center>Il n'y a rien  rsoudre."\
					   "<br>Veuillez vrifier vos coefficients."));




} // Primal ()



void Interface::Dual()
{
	QTableWidget *NewMatrice  = new QTableWidget();
	copyTable (*Transpose (*ui.Matrice), *NewMatrice);

	QTableWidget *T  = new QTableWidget();
	copyTable (*NewMatrice, *T);


    QWidget *tabT = new QWidget();
    QGridLayout *gridLayout = new QGridLayout(tabT);
    gridLayout->addWidget(T, 0, 0, 1, 1);


	int nbVar = ui.spinBox_Ctr->value();
	int nbCtr = ui.spinBox_Var->value();

	int nbLig = NewMatrice->rowCount();
	int nbCol = NewMatrice->columnCount();


    // On cr un tableau d'indices de rsultats
    int LigRes [nbLig - 1];
    int ColRes [nbCol - 1];

    for (unsigned int i = 0; i < nbVar; ++i)
    {
        LigRes [i] = nbLig - 1;
        ColRes [i] = i;
    }
    
    for (unsigned int i = 0; i < nbCtr; ++i)
    {
        LigRes [i + nbVar] = i; 
        ColRes [i + nbVar] = nbCol - 1;
    }


	int    Col, Lig, ColPivot, LigPivot;
	double LigCol, LigPivotCol, LigColPivot;
    double NbPivot;
	double Item;

	bool   Sortie;

	ostringstream ostr, os;

	ColPivot = getColPivot (*NewMatrice);
	LigPivot = getLigPivot (*NewMatrice, ColPivot);
	NbPivot  = NewMatrice->item( LigPivot, ColPivot )->text().toDouble();

    ui.ongletsMatrices->addTab(tabT, "Transp");
	ui.ongletsMatrices->setTabText(ui.ongletsMatrices->indexOf(tabT), "Transpose");

	int Et = 1;
    for ( ; ; ++Et)
    {
		QTableWidget *AffMatrice = new QTableWidget();

		if (Et > 1)
		{
			// On cr un nouvel onglet contenant la NewMatrice actuelle
			copyTable (*NewMatrice, *AffMatrice);
	
			QWidget *tab = new QWidget();
	    	QGridLayout *gridLayout = new QGridLayout(tab);

	    	gridLayout->addWidget(AffMatrice, 0, 0, 1, 1);
	
			os << "Etape " << Et - 1;
	
	    	ui.ongletsMatrices->addTab(tab, os.str().c_str());
			ui.ongletsMatrices->setTabText(ui.ongletsMatrices->indexOf(tab), os.str().c_str());
	
			os.str("");
	
	
			// On rcupre les nouveaux "pivots"
			ColPivot = getColPivot (*NewMatrice);
			LigPivot = getLigPivot (*NewMatrice, ColPivot);
	        NbPivot  = NewMatrice->item( LigPivot, ColPivot )->text().toDouble();

		}


        // Condition d'arrt : tous les coeff <= 0
        for (int i = 0; i < nbVar; ++i)
        {
			if (NewMatrice->item(nbLig-1, i)->text().toDouble())
			    Item = NewMatrice->item(nbLig-1, i)->text().toDouble();
			else
				Item = 0;

            if (Item > 0) 
            {
                Sortie = false;
                break;
            }
            Sortie = true;
        }
        if (Sortie) break;


		// On colorie la ligne pivot et la colonne pivot
		if (Et > 1) paintTable (*AffMatrice, LigPivot, ColPivot);
		else		paintTable (*T, LigPivot, ColPivot);


		// Le libell de LigPivot est remplac par celui de ColPivot
		NewMatrice->setVerticalHeaderItem
			(LigPivot, new QTableWidgetItem (NewMatrice->horizontalHeaderItem (ColPivot)->text()));


        // On remplit le tableau d'indices de rsultats
        LigRes [ColPivot] = LigPivot;
        ColRes [ColPivot] = nbCol - 1;
        LigRes [LigPivot + nbVar] = - 1;


		// Modifications des valeurs de NewMatrice
        for (Col = 0; Col < nbCol; ++Col)
        {
            // On ne traite pas la colonne pivot
            if (Col == ColPivot) continue;

            // Pour chaque ligne, on retire  la valeur le produit de ses 
            // correspondants sur LigPivot et ColPivot diviss par NbPivot
            for (Lig = 0; Lig < nbLig; ++Lig)
            {
                // On ne traite pas la ligne pivot
                if (Lig == LigPivot) continue;

				LigCol 		= (*NewMatrice->item( Lig, Col )).text().toDouble();
				LigPivotCol = (*NewMatrice->item( LigPivot, Col )).text().toDouble();
				LigColPivot = (*NewMatrice->item( Lig, ColPivot )).text().toDouble();

				os << LigCol - (LigPivotCol * LigColPivot) / NbPivot;
    			NewMatrice->setItem(Lig, Col, new QTableWidgetItem (os.str().c_str()));
				os.str("");
            }
        }


		// On divise la ligne pivot par le nombre pivot
        for (Col = 0; Col < nbCol; ++Col)
        {
			os << NewMatrice->item( LigPivot, Col )->text().toDouble() / NbPivot;
    		NewMatrice->setItem( LigPivot, Col, new QTableWidgetItem (os.str().c_str()));
			os.str("");
        }


        // On remplace les valeurs de ColPivot par 0 sauf pour LigPivot  
        for (Lig = 0; Lig < nbLig; ++Lig)
        {
            if (Lig == LigPivot) continue;

    		NewMatrice->setItem(Lig, ColPivot, new QTableWidgetItem ("0"));
        }


    } // Itrations



	if (Et != 1)
	{
	    ostr << "<b>Variables :</b><br>";
	
	    for (Col = nbVar; Col < nbCol - 1; ++Col)
	    {
			ostr << "<br>"
				 << ui.Matrice->horizontalHeaderItem(Col - nbVar)->text().toStdString() 
				 << " = ";
		
	        // Affichage du rsultat
	        if (LigRes [Col] == -1)
	            ostr << 0;
	        else
	            ostr << NewMatrice->item( LigRes[Col], ColRes[Col] )->text().toDouble();

	    }

		ostr << "<br><br><b>Contraintes :</b><br>";

	    for (Col = 0; Col < nbVar; ++Col)
	    {
			ostr << "<br>"
				 << ui.Matrice->horizontalHeaderItem(Col + nbVar + 1)->text().toStdString() 
				 << " = ";
		
	        // Affichage du rsultat
	        if (LigRes [Col] == -1)
	            ostr << 0;
	        else
	            ostr << NewMatrice->item( LigRes[Col], ColRes[Col] )->text().toDouble();

	    }
	
	    ostr << setprecision(15) << "<br><br><b> Z = " 
	         << - (NewMatrice->item( nbLig-1 , nbCol-1 )->text().toDouble()) << "<br><br>";

	
		ui.ongletsMatrices->setTabText(ui.ongletsMatrices->count() - 1, "Matrice finale");

		// Cration d'un nouvel onglet Rsultat
	    QWidget *tabF = new QWidget();
	    QGridLayout *gridLayout = new QGridLayout(tabF);
	
	    QTextEdit *text = new QTextEdit(tabF);
		text->setReadOnly(true);
	    gridLayout->addWidget(text, 0, 0, 1, 1);
	
	    ui.ongletsMatrices->addTab(tabF, "Tab Finale");
		ui.ongletsMatrices->setTabText(ui.ongletsMatrices->indexOf(tabF), "Rsultats");
		ui.ongletsMatrices->setCurrentIndex(ui.ongletsMatrices->count() - 1);

		text->setHtml (ostr.str().c_str());


		ostringstream olog;	
		olog << "Problme dual rsolu : Z = "
	         << - ((*NewMatrice->item( nbLig-1 , nbCol-1 )).text().toDouble());
		Log (olog.str(), "red");
		olog.str("");

	}
	else
		QMessageBox::information(ui.centralwidget, 
					tr("Bizarre..."),
					tr("<p align=center>Il n'y a rien  rsoudre."\
					   "<br>Veuillez vrifier vos coefficients."));


} // Dual ()








///////////////////////////////
//                           //
//     FONCTIONS DU MENU     //
//                           //
///////////////////////////////


void Interface::Nouveau()
{
	if (IsModif)
	{
		int reply = QMessageBox::question(ui.centralwidget, 
					tr("Nouvelle Matrice"),
	                tr("<p align=center>La matrice initiale a t modifie."\
					   "<p align=center>Voulez-vous la sauvegarder ?"),
	                   QMessageBox::Yes, QMessageBox::No);
	
	    if (reply == QMessageBox::Yes)
	        Exporter();
	}

	clearTab();
    ui.Matrice->clear();
    ui.Matrice->setColumnCount(3);
    ui.Matrice->setRowCount(2);
    ui.spinBox_Ctr->setValue(1);
    ui.spinBox_Var->setValue(1);
	labelTable();
    redimTable(*ui.Matrice);

	for (int i = 0; i < ui.Matrice->rowCount()   ; ++i)
	for (int j = 0; j < ui.Matrice->columnCount(); ++j)
    	ui.Matrice->setItem(i, j, new QTableWidgetItem());


	Log ("Nouvelle matrice cre", "purple");
	IsModif = false;

} // Nouveau ()



void Interface::Exporter()
{
	QFileDialog *Save = new QFileDialog();
	Save->showExtension(true);
    QString fileName = Save->getSaveFileName(ui.centralwidget,
                                tr("Exporter la matrice"),
                                tr("Matrice.xls"),
                                tr("Fichier Excel (*.xls);;Fichier Texte (*.txt);;Tous les fichiers (*)"));

	if (!fileName.isEmpty())
	{
	  try
	  {
		int nbLig = ui.Matrice->rowCount();
		int nbCol = ui.Matrice->columnCount();

    	ofstream os (fileName.toStdString().c_str());
		
		if (!os) throw (1);

		string Str;

		os << '\t';

		for (int i = 0; i < nbCol; ++i)
			os << ui.Matrice->horizontalHeaderItem(i)->text().toStdString() << '\t';

		os << '\n';			

    	for (int i = 0; i < nbLig; i++)
		{
			os << ui.Matrice->verticalHeaderItem(i)->text().toStdString() << '\t';
	    	for (int j = 0; j < nbCol; j++)
			{
		 		if (ui.Matrice->item(i,j)->text().toDouble())
			    	Str = ui.Matrice->item(i,j)->text().toStdString();
				else
					Str = "0";

        		os << Str << '\t';
    		}
			os << '\n';
		}

		ostringstream ostr;
		ostr << "Matrice exporte vers \"" << fileName.toStdString() << "\"";
		Log (ostr.str(), "green");

		IsModif = false;

	  } // try

	  catch (int err)
	  {
		if (err == 1)
			QMessageBox::warning(ui.centralwidget, 
				tr(" Oops !!"),
				tr("<p align=center>Erreur lors de l'exportation :"\
				   "<p align=center>vous ne bnfissiez pas des droits "\
				   "ncessaires pour crire dans ce fichier."));
		
	  } // catch

	} // if

} // Exporter ()



void Interface::Importer()
{
	if (IsModif)
	{
		int reply = QMessageBox::question(ui.centralwidget, 
					tr("Importer une matrice"),
	                tr("<p align=center>La matrice initiale a t modifie."\
					   "<p align=center>Voulez-vous la sauvegarder ?"),
	                   QMessageBox::Yes, QMessageBox::No);
	
	    if (reply == QMessageBox::Yes)
	        Exporter();
	}

    QString fileName = QFileDialog::getOpenFileName(ui.centralwidget,
                                tr("Importer une matrice"),
                                tr("Slectionnez votre fichier"),
                                tr("Fichiers Excel ou Texte (*.xls *.txt)"));

	if (!fileName.isEmpty())
	{
	  try
	  {
		int Lig = 0;
		int Col = 0;

		int nbLig = 0;
		int nbCol = 0;
	
		ostringstream oss;
		string Saisie;
		double Nb;

		ifstream ifss (fileName.toStdString().c_str());

		if (!ifss) throw (2);

		if (!getline (ifss, Saisie)) throw (1);
	
		// Compte le nombre de colonnes
		for (int i = 0 ; i < Saisie.size(); ++i)
			if (Saisie[i] == '\t') ++nbCol;


		// Compte le nombre de lignes
	    for ( ; !ifss.eof(); getline (ifss, Saisie))
	    {
			int Cpt = 0;
			for (int i = 0; i < Saisie.size(); ++i)
				if (Saisie[i] == '\t') ++Cpt;

			if (Cpt != nbCol) throw (3);

			++nbLig;
		}

		--nbCol;
		--nbLig;

		if (nbCol < 3 || nbLig < 2) throw (3);


		clearTab();
	
	    ui.Matrice->clear();
	    ui.Matrice->setColumnCount(0);
	    ui.Matrice->setRowCount(0);

		ui.spinBox_Var->setValue(nbCol - nbLig);
		ui.spinBox_Ctr->setValue(nbLig - 1);

		ifss.close();


		ifstream ifs (fileName.toStdString().c_str());
		getline (ifs, Saisie);

		ui.Matrice->setColumnCount(nbCol);
		ui.Matrice->setRowCount(nbLig);

		string Nom;

		istringstream is (Saisie);

		for (int i = 0; i < nbCol; ++i)
		{
			is >> Nom;
			ui.Matrice->setHorizontalHeaderItem(i, new 	QTableWidgetItem (Nom.c_str()));
		}

		getline (ifs, Saisie);

		// Remplit la Matrice
	    for ( ; !ifs.eof(); getline (ifs, Saisie), ++Lig)
	    {
			Col = 0;

			istringstream iss (Saisie);
			iss >> Nom;

			ui.Matrice->setVerticalHeaderItem(Lig, new QTableWidgetItem (Nom.c_str()));


	        // Entre des valeurs dans la Matrice
	        for ( ; iss >> Nb; ++Col)
	        {
				oss << Nb;

				QTableWidgetItem *__item = new QTableWidgetItem();
	    		__item->setText(oss.str().c_str());
				__item->setTextAlignment (Qt::AlignHCenter | Qt::AlignVCenter);
	    		ui.Matrice->setItem(Lig, Col, __item);
	
				oss.str("");
	        }
	    }
		ifs.close();

	
	    redimTable(*ui.Matrice);
	
		ostringstream ostr;
		ostr << "Matrice importe de \"" << fileName.toStdString() << '\"';
		Log (ostr.str(), "green");

	//	labelTable();
		IsModif = false;

	  } // try

	  catch (int err)
	  {
		string messErr 
		("<p align=center>Erreur lors de l'importation :<p align=center>");

		if (err == 1)
		messErr += "le fichier slectionn est vide.";
			
		if (err == 2)
		messErr += "vous ne bnfissez pas des droits ncessaires pour lire ce fichier.";

		if (err == 3)
		messErr += "mauvais format de fichier.";

		messErr += "<br></p>";

		QMessageBox::warning(ui.centralwidget, 
				tr(" Oops !!"),
				tr(messErr.c_str()));

	  } // catch

	} // if

} // Importer ()




void Interface::RenameVar()
{
	ostringstream num;

	for (int i = 0; i < ui.spinBox_Var->value(); ++i)
	{
		num << 'X' << i + 1;
		bool ok;
    	QString text = QInputDialog::getText(ui.centralwidget,
											 "Renommer variable",
											 num.str().c_str(), 
											 QLineEdit::Normal,
            	                             ui.Matrice->horizontalHeaderItem (i)->text(), &ok);

    	if (ok && !text.isEmpty())
		{
			// Remplace les espaces par des tirets
			string Str (text.toStdString());
			for (int j = 0; j < Str.size(); ++j)
				if (Str[j] == ' ') Str[j] = '-';

			ui.Matrice->setHorizontalHeaderItem (i, new QTableWidgetItem(Str.c_str()));
		}

		num.str("");
	}

	IsModif = true;
	Log("Variables renommes", "purple");

}



void Interface::RenameCtr()
{
	ostringstream num;

	int nbVar = ui.spinBox_Var->value();
	int nbCtr = ui.spinBox_Ctr->value();

	for (int i = 0; i < nbCtr; ++i)
	{
		num << 'e' << i + 1;
		bool ok;
    	QString text = QInputDialog::getText(ui.centralwidget,
											 tr("Renommer contrainte"),
											 num.str().c_str(), 
											 QLineEdit::Normal,
            	                             ui.Matrice->verticalHeaderItem (i)->text(), &ok);
    	if (ok && !text.isEmpty())
		{
			// Remplace les espaces par des tirets
			string Str (text.toStdString());
			for (int j = 0; j < Str.size(); ++j)
				if (Str[j] == ' ') Str[j] = '-';

			ui.Matrice->setVerticalHeaderItem (i, new QTableWidgetItem(Str.c_str()));
			ui.Matrice->setHorizontalHeaderItem (i + nbVar, new QTableWidgetItem(Str.c_str()));
		}
		num.str("");
	}

	IsModif = true;
	Log("Contraintes renommes", "purple");

} // RenameCtr ()








////////////////////////
//                    //
//      ACTIONS       //
//                    //
////////////////////////


void Interface::on_spinBox_Ctr_valueChanged()
{
	ui.ongletsMatrices->setCurrentIndex(0);
	clearTab();

	int OldNbCol = ui.Matrice->columnCount();
	int NewNbCol = ui.spinBox_Var->value() + ui.spinBox_Ctr->value() + 1;
	int OldNbLig = ui.Matrice->rowCount();
	int NewNbLig = ui.spinBox_Ctr->value() + 1;

    ui.Matrice->setColumnCount(NewNbCol);
    ui.Matrice->setRowCount	  (NewNbLig);
    redimTable(*ui.Matrice);

	// Si La nouvelle valeur de la spinBox est plus grande
	if (OldNbCol < NewNbCol)
	{
		// On cr le nombre de lignes appropri
		for (int i = 0; i < ui.Matrice->rowCount(); ++i)
		for (int j = OldNbCol; j < NewNbCol; ++j)
    		ui.Matrice->setItem(i, j, new QTableWidgetItem());

		
		// On cr le nombre de colonnes appropri
		for (int i = 0; i < ui.Matrice->columnCount(); ++i)
		for (int j = OldNbLig; j < NewNbLig; ++j)
    		ui.Matrice->setItem(j, i, new QTableWidgetItem());
	}

	labelTable();

} // spinbox_ctr ()



void Interface::on_spinBox_Var_valueChanged()
{
	ui.ongletsMatrices->setCurrentIndex(0);
	clearTab();

	int OldNbCol = ui.Matrice->columnCount();
	int NewNbCol = ui.spinBox_Var->value() + ui.spinBox_Ctr->value() + 1;

    ui.Matrice->setColumnCount(NewNbCol);
    redimTable(*ui.Matrice);

	// Si La nouvelle valeur de la spinBox est plus grande
	if (OldNbCol < NewNbCol)
	{
		// On cr le nombre de lignes appropri
		for (int i = 0; i < ui.Matrice->rowCount(); ++i)
		for (int j = OldNbCol; j < NewNbCol; ++j)
    		ui.Matrice->setItem(i, j, new QTableWidgetItem());
	}

	labelTable();

} // spinbox_var ()





void Interface::on_buttonRes_clicked()
{
	clearTab();

	if (ui.radioButton_Dual->isChecked())
		Dual();
	else
		Primal();

} // buttonRes ()




void Interface::on_buttonVar_clicked()
	{ RenameVar(); }


void Interface::on_buttonCtr_clicked()
	{ RenameCtr(); }



void Interface::on_Matrice_itemChanged(QTableWidgetItem *item)
{
	clearTab();

	if ( ! item->text().toDouble())
	{
		if (item->text().toStdString() != "0" && item->text().toStdString() != "")
			QMessageBox::warning(ui.centralwidget, 
				tr(" Attention !!"),
				tr("<p align=center>Vous ne pouvez pas rentrer de chaines<br>de caractres dans la matrice."\
				   "<br>(ceci inclut les fractions)</p>"));

	    item->setText ("0");
		item->setTextAlignment (Qt::AlignHCenter | Qt::AlignVCenter);
	}

	IsModif = true;
}


void Interface::on_buttonNouveau_clicked()
	{ Nouveau(); }


void Interface::on_buttonExporter_clicked()
	{ Exporter(); }


void Interface::on_buttonImporter_clicked()
	{ Importer(); }

////////////////////////////////////////////////////////////////////////////////

void Interface::on_actionNouveau_activated()
	{ Nouveau(); }


void Interface::on_actionExporter_activated()
	{ Exporter(); }


void Interface::on_actionImporter_activated()
	{ Importer(); }


void Interface::on_actionQuitter_activated()
	{ close(); }


void Interface::closeEvent (QCloseEvent *event)
{
	if (IsModif) 
	{
		int reply = QMessageBox::question(ui.centralwidget, 
					"Quitter ProgLineaireGUI",
        			"<p align=center>La matrice initiale a t modifie."\
					"<p align=center>Voulez-vous la sauvegarder ?",
        			QMessageBox::Yes, QMessageBox::No, QMessageBox::Cancel);

    	if (reply == QMessageBox::Yes)
        	Exporter();

		if (reply == QMessageBox::Cancel)
		{
			Log ("Vous avez failli quitter","darkblue");
			event->ignore();
		}

	}

} // closeEvent ()


////////////////////////////////////////////////////////////////////////////////


void Interface::on_actionNomVar_activated()
	{ RenameVar(); }


void Interface::on_actionNomCtr_activated()
	{ RenameCtr(); }


////////////////////////////////////////////////////////////////////////////////


void Interface::on_actionTout_activated()
{
	if (!ui.actionTout->isChecked())
	{
		ui.actionTout->setChecked		(false);
		ui.actionSaisies->setChecked	(false);
		ui.actionMini_Menu->setChecked	(false);
		ui.actionLog->setChecked		(false);
		ui.boxSaisies->setVisible		(false);
		ui.boxMini_Menu->setVisible		(false);
		ui.boxLog->setVisible			(false);
	}
	else
	{
		ui.actionTout->setChecked		(true);
		ui.actionSaisies->setChecked	(true);
		ui.actionMini_Menu->setChecked	(true);
		ui.actionLog->setChecked		(true);
		ui.boxSaisies->setVisible		(true);
		ui.boxMini_Menu->setVisible		(true);
		ui.boxLog->setVisible			(true);
	}

}


void Interface::on_actionSaisies_activated()
{
	if (!ui.actionSaisies->isChecked())
	{
		ui.actionSaisies->setChecked(false);
		ui.boxSaisies->setVisible(false);
	}
	else
	{
		ui.actionSaisies->setChecked(true);
		ui.boxSaisies->setVisible(true);
	}

	if (ui.actionMini_Menu->isChecked() && ui.actionSaisies->isChecked() && ui.actionLog->isChecked())
		ui.actionTout->setChecked(true);

	if (!ui.actionMini_Menu->isChecked() && !ui.actionSaisies->isChecked() && !ui.actionLog->isChecked())
		ui.actionTout->setChecked(false);
}

void Interface::on_actionMini_Menu_activated()
{
	if (!ui.actionMini_Menu->isChecked())
	{
		ui.actionMini_Menu->setChecked(false);
		ui.boxMini_Menu->setVisible(false);
	}
	else
	{
		ui.actionMini_Menu->setChecked(true);
		ui.boxMini_Menu->setVisible(true);
	}

	if (ui.actionMini_Menu->isChecked() && ui.actionSaisies->isChecked() && ui.actionLog->isChecked())
		ui.actionTout->setChecked(true);

	if (!ui.actionMini_Menu->isChecked() && !ui.actionSaisies->isChecked() && !ui.actionLog->isChecked())
		ui.actionTout->setChecked(false);

}

void Interface::on_actionLog_activated()
{
	if (!ui.actionLog->isChecked())
	{
		ui.actionLog->setChecked(false);
		ui.boxLog->setVisible(false);
	}
	else
	{
		ui.actionLog->setChecked(true);
		ui.boxLog->setVisible(true);
	}

	if (ui.actionMini_Menu->isChecked() && ui.actionSaisies->isChecked() && ui.actionLog->isChecked())
		ui.actionTout->setChecked(true);

	if (!ui.actionMini_Menu->isChecked() && !ui.actionSaisies->isChecked() && !ui.actionLog->isChecked())
		ui.actionTout->setChecked(false);
}

////////////////////////////////////////////////////////////////////////////////


void Interface::on_actionReadme_activated()
{
	ShellExecute (NULL, "open", "Readme.doc", NULL, NULL, SW_SHOWDEFAULT);
}


void Interface::on_actionAPropos_activated()
{
	QMessageBox::information(ui.centralwidget, 
				tr("A Propos de ProgLineaireGUI"),
				tr("<p align=center><font size=5 color=darkblue><b>A propos de ProgLineaireGUI</b></font></p>"\
				   "<p align=left><br><br><b>Version :</b> 0.1b<br>"\
				   "<p align=left><b>Auteurs :</b> Camille Descombes et Mickal Marmol<br>"\
				   "<p align=left><b>Logiciel :</b> Dev-C++ 4.9.9.2 avec la bibliothque logicielle Qt 4.1.4<br>"\
				   "<p align=left><b>Licence :</b> GNU/GPL voir <font color=blue>http://fsffrance.org/gpl/gpl-fr.fr.html</font><br><br></p>"));
}
