       /****************************************************************\
      * *           Dclarations des fonctions de l'interface          * *
     *   **************************************************************   *
    *     *   @ Authors : C. Descombes, M. Marmol                    *     *
   *   *   *                                                        *   *   *
    *     *   @ Date    : 19/10/2006                                 *     *
     *   *                                                            *   *
      * *     @ File    : interface.h                                  * *
       \****************************************************************/


#ifndef __INTERFACE_H__
#define __INTERFACE_H__

#include "ui_interface.h"

class Interface : public QMainWindow
{
    Q_OBJECT

  public:
    Interface(QMainWindow *parent = 0);

	void clearTab   ();
	void labelTable	();
	void redimTable	(QTableWidget &M, int Size = 72);
	void copyTable	(QTableWidget &Old, QTableWidget &New);
	void Log		(std::string Str, std::string Color = "black");
	void paintTable (QTableWidget &M, int Lig, int Col);

	QTableWidget *Transpose (QTableWidget &M);

  protected:
    void Nouveau();
	void Exporter();
	void Importer();
    void closeEvent (QCloseEvent *event);

	void RenameVar();
	void RenameCtr();

	int getColPivot (QTableWidget &M);
	int getLigPivot (QTableWidget &M, int ColPivot);

	void Primal();
	void Dual();


  private slots:
	// SPINBOX    
    void on_spinBox_Var_valueChanged();
    void on_spinBox_Ctr_valueChanged();
    
	// MENU
    void on_actionNouveau_activated();
    void on_actionExporter_activated();
    void on_actionImporter_activated();
	void on_actionQuitter_activated();

	void on_actionNomVar_activated();
	void on_actionNomCtr_activated();

	void on_actionTout_activated();
	void on_actionSaisies_activated();
	void on_actionMini_Menu_activated();
	void on_actionLog_activated();

	void on_actionReadme_activated();
	void on_actionAPropos_activated();

	// BOUTONS
	void on_buttonRes_clicked();
	void on_buttonVar_clicked();
	void on_buttonCtr_clicked();
	void on_buttonNouveau_clicked();
	void on_buttonExporter_clicked();
	void on_buttonImporter_clicked();

	// EVENEMENTS
	void on_Matrice_itemChanged(QTableWidgetItem *item);

  private:
    Ui::MainWindow ui;
    
};

#endif
