#ifndef UI_INTERFACE_H
#define UI_INTERFACE_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QMainWindow>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QSpinBox>
#include <QtGui/QSplitter>
#include <QtGui/QStatusBar>
#include <QtGui/QTabWidget>
#include <QtGui/QTableWidget>
#include <QtGui/QTextEdit>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>

class Ui_MainWindow
{
public:
    QAction *actionNouveau;
    QAction *actionQuitter;
    QAction *actionExporter;
    QAction *actionImporter;
    QAction *actionAPropos;
    QAction *actionLog;
    QAction *actionNomVar;
    QAction *actionNomCtr;
    QAction *actionReadme;
    QAction *actionExcel;
    QAction *actionSaisies;
    QAction *actionMini_Menu;
    QAction *actionTout;
    QWidget *centralwidget;
    QVBoxLayout *vboxLayout;
    QSplitter *splitter;
    QTabWidget *ongletsMatrices;
    QWidget *tab_init;
    QGridLayout *gridLayout;
    QTableWidget *Matrice;
    QWidget *widget;
    QGridLayout *gridLayout1;
    QSpacerItem *spacerItem;
    QSpacerItem *spacerItem1;
    QGroupBox *boxMini_Menu;
    QHBoxLayout *hboxLayout;
    QSpacerItem *spacerItem2;
    QVBoxLayout *vboxLayout1;
    QPushButton *buttonNouveau;
    QPushButton *buttonExporter;
    QPushButton *buttonImporter;
    QSpacerItem *spacerItem3;
    QHBoxLayout *hboxLayout1;
    QPushButton *buttonRes;
    QVBoxLayout *vboxLayout2;
    QRadioButton *radioButton_Primal;
    QRadioButton *radioButton_Dual;
    QGroupBox *boxLog;
    QVBoxLayout *vboxLayout3;
    QTextEdit *textLog;
    QSpacerItem *spacerItem4;
    QGroupBox *boxSaisies;
    QVBoxLayout *vboxLayout4;
    QGridLayout *gridLayout2;
    QLabel *label_Ctr;
    QLabel *label_Var;
    QSpinBox *spinBox_Var;
    QSpinBox *spinBox_Ctr;
    QSpacerItem *spacerItem5;
    QPushButton *buttonVar;
    QPushButton *buttonCtr;
    QMenuBar *menubar;
    QMenu *menu;
    QMenu *menuFichier;
    QMenu *menuEdition;
    QMenu *menuAfficher;
    QStatusBar *statusbar;

    void setupUi(QMainWindow *MainWindow)
    {
    MainWindow->setObjectName(QString::fromUtf8("MainWindow"));
    MainWindow->setEnabled(true);
    MainWindow->resize(QSize(800, 600).expandedTo(MainWindow->minimumSizeHint()));
    QSizePolicy sizePolicy(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(7));
    sizePolicy.setHorizontalStretch(0);
    sizePolicy.setVerticalStretch(0);
    sizePolicy.setHeightForWidth(MainWindow->sizePolicy().hasHeightForWidth());
    MainWindow->setSizePolicy(sizePolicy);
    MainWindow->setMinimumSize(QSize(640, 480));
    MainWindow->setMaximumSize(QSize(16777215, 16777215));
    MainWindow->setWindowIcon(QIcon(QString::fromUtf8("Icone.JPG")));
    actionNouveau = new QAction(MainWindow);
    actionNouveau->setObjectName(QString::fromUtf8("actionNouveau"));
    actionQuitter = new QAction(MainWindow);
    actionQuitter->setObjectName(QString::fromUtf8("actionQuitter"));
    actionExporter = new QAction(MainWindow);
    actionExporter->setObjectName(QString::fromUtf8("actionExporter"));
    actionImporter = new QAction(MainWindow);
    actionImporter->setObjectName(QString::fromUtf8("actionImporter"));
    actionAPropos = new QAction(MainWindow);
    actionAPropos->setObjectName(QString::fromUtf8("actionAPropos"));
    actionLog = new QAction(MainWindow);
    actionLog->setObjectName(QString::fromUtf8("actionLog"));
    actionLog->setCheckable(true);
    actionLog->setChecked(true);
    actionNomVar = new QAction(MainWindow);
    actionNomVar->setObjectName(QString::fromUtf8("actionNomVar"));
    actionNomCtr = new QAction(MainWindow);
    actionNomCtr->setObjectName(QString::fromUtf8("actionNomCtr"));
    actionReadme = new QAction(MainWindow);
    actionReadme->setObjectName(QString::fromUtf8("actionReadme"));
    actionExcel = new QAction(MainWindow);
    actionExcel->setObjectName(QString::fromUtf8("actionExcel"));
    actionSaisies = new QAction(MainWindow);
    actionSaisies->setObjectName(QString::fromUtf8("actionSaisies"));
    actionSaisies->setCheckable(true);
    actionSaisies->setChecked(true);
    actionMini_Menu = new QAction(MainWindow);
    actionMini_Menu->setObjectName(QString::fromUtf8("actionMini_Menu"));
    actionMini_Menu->setCheckable(true);
    actionMini_Menu->setChecked(true);
    actionTout = new QAction(MainWindow);
    actionTout->setObjectName(QString::fromUtf8("actionTout"));
    actionTout->setCheckable(true);
    actionTout->setChecked(true);
    centralwidget = new QWidget(MainWindow);
    centralwidget->setObjectName(QString::fromUtf8("centralwidget"));
    centralwidget->setMinimumSize(QSize(400, 300));
    vboxLayout = new QVBoxLayout(centralwidget);
    vboxLayout->setSpacing(6);
    vboxLayout->setMargin(9);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
    splitter = new QSplitter(centralwidget);
    splitter->setObjectName(QString::fromUtf8("splitter"));
    splitter->setOrientation(Qt::Vertical);
    ongletsMatrices = new QTabWidget(splitter);
    ongletsMatrices->setObjectName(QString::fromUtf8("ongletsMatrices"));
    QSizePolicy sizePolicy1(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(7));
    sizePolicy1.setHorizontalStretch(0);
    sizePolicy1.setVerticalStretch(208);
    sizePolicy1.setHeightForWidth(ongletsMatrices->sizePolicy().hasHeightForWidth());
    ongletsMatrices->setSizePolicy(sizePolicy1);
    ongletsMatrices->setTabShape(QTabWidget::Rounded);
    tab_init = new QWidget();
    tab_init->setObjectName(QString::fromUtf8("tab_init"));
    gridLayout = new QGridLayout(tab_init);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(9);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    Matrice = new QTableWidget(tab_init);
    Matrice->setObjectName(QString::fromUtf8("Matrice"));

    gridLayout->addWidget(Matrice, 0, 0, 1, 1);

    ongletsMatrices->addTab(tab_init, QApplication::translate("MainWindow", "Matrice initiale", 0, QApplication::UnicodeUTF8));
    splitter->addWidget(ongletsMatrices);
    widget = new QWidget(splitter);
    widget->setObjectName(QString::fromUtf8("widget"));
    gridLayout1 = new QGridLayout(widget);
    gridLayout1->setSpacing(6);
    gridLayout1->setMargin(0);
    gridLayout1->setObjectName(QString::fromUtf8("gridLayout1"));
    spacerItem = new QSpacerItem(50, 181, QSizePolicy::Preferred, QSizePolicy::Minimum);

    gridLayout1->addItem(spacerItem, 0, 1, 3, 1);

    spacerItem1 = new QSpacerItem(20, 15, QSizePolicy::Minimum, QSizePolicy::Maximum);

    gridLayout1->addItem(spacerItem1, 0, 2, 1, 1);

    boxMini_Menu = new QGroupBox(widget);
    boxMini_Menu->setObjectName(QString::fromUtf8("boxMini_Menu"));
    QSizePolicy sizePolicy2(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(0));
    sizePolicy2.setHorizontalStretch(0);
    sizePolicy2.setVerticalStretch(0);
    sizePolicy2.setHeightForWidth(boxMini_Menu->sizePolicy().hasHeightForWidth());
    boxMini_Menu->setSizePolicy(sizePolicy2);
    boxMini_Menu->setMinimumSize(QSize(140, 120));
    boxMini_Menu->setMaximumSize(QSize(140, 120));
    hboxLayout = new QHBoxLayout(boxMini_Menu);
    hboxLayout->setSpacing(6);
    hboxLayout->setMargin(9);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    spacerItem2 = new QSpacerItem(16, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout->addItem(spacerItem2);

    vboxLayout1 = new QVBoxLayout();
    vboxLayout1->setSpacing(6);
    vboxLayout1->setMargin(0);
    vboxLayout1->setObjectName(QString::fromUtf8("vboxLayout1"));
    buttonNouveau = new QPushButton(boxMini_Menu);
    buttonNouveau->setObjectName(QString::fromUtf8("buttonNouveau"));
    buttonNouveau->setMinimumSize(QSize(100, 25));
    buttonNouveau->setMaximumSize(QSize(100, 25));

    vboxLayout1->addWidget(buttonNouveau);

    buttonExporter = new QPushButton(boxMini_Menu);
    buttonExporter->setObjectName(QString::fromUtf8("buttonExporter"));
    buttonExporter->setMinimumSize(QSize(100, 25));
    buttonExporter->setMaximumSize(QSize(100, 25));

    vboxLayout1->addWidget(buttonExporter);

    buttonImporter = new QPushButton(boxMini_Menu);
    buttonImporter->setObjectName(QString::fromUtf8("buttonImporter"));
    buttonImporter->setMinimumSize(QSize(100, 25));
    buttonImporter->setMaximumSize(QSize(100, 25));

    vboxLayout1->addWidget(buttonImporter);


    hboxLayout->addLayout(vboxLayout1);

    spacerItem3 = new QSpacerItem(20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout->addItem(spacerItem3);


    gridLayout1->addWidget(boxMini_Menu, 2, 2, 1, 1);

    hboxLayout1 = new QHBoxLayout();
    hboxLayout1->setSpacing(6);
    hboxLayout1->setMargin(0);
    hboxLayout1->setObjectName(QString::fromUtf8("hboxLayout1"));
    buttonRes = new QPushButton(widget);
    buttonRes->setObjectName(QString::fromUtf8("buttonRes"));
    QSizePolicy sizePolicy3(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(0));
    sizePolicy3.setHorizontalStretch(0);
    sizePolicy3.setVerticalStretch(0);
    sizePolicy3.setHeightForWidth(buttonRes->sizePolicy().hasHeightForWidth());
    buttonRes->setSizePolicy(sizePolicy3);
    buttonRes->setMinimumSize(QSize(140, 40));
    buttonRes->setMaximumSize(QSize(140, 40));

    hboxLayout1->addWidget(buttonRes);

    vboxLayout2 = new QVBoxLayout();
    vboxLayout2->setSpacing(0);
    vboxLayout2->setMargin(0);
    vboxLayout2->setObjectName(QString::fromUtf8("vboxLayout2"));
    radioButton_Primal = new QRadioButton(widget);
    radioButton_Primal->setObjectName(QString::fromUtf8("radioButton_Primal"));
    radioButton_Primal->setChecked(true);

    vboxLayout2->addWidget(radioButton_Primal);

    radioButton_Dual = new QRadioButton(widget);
    radioButton_Dual->setObjectName(QString::fromUtf8("radioButton_Dual"));

    vboxLayout2->addWidget(radioButton_Dual);


    hboxLayout1->addLayout(vboxLayout2);


    gridLayout1->addLayout(hboxLayout1, 1, 2, 1, 2);

    boxLog = new QGroupBox(widget);
    boxLog->setObjectName(QString::fromUtf8("boxLog"));
    QSizePolicy sizePolicy4(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(7));
    sizePolicy4.setHorizontalStretch(0);
    sizePolicy4.setVerticalStretch(0);
    sizePolicy4.setHeightForWidth(boxLog->sizePolicy().hasHeightForWidth());
    boxLog->setSizePolicy(sizePolicy4);
    vboxLayout3 = new QVBoxLayout(boxLog);
    vboxLayout3->setSpacing(6);
    vboxLayout3->setMargin(9);
    vboxLayout3->setObjectName(QString::fromUtf8("vboxLayout3"));
    textLog = new QTextEdit(boxLog);
    textLog->setObjectName(QString::fromUtf8("textLog"));
    textLog->setFrameShape(QFrame::Box);
    textLog->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
    textLog->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    textLog->setReadOnly(true);

    vboxLayout3->addWidget(textLog);


    gridLayout1->addWidget(boxLog, 0, 4, 3, 1);

    spacerItem4 = new QSpacerItem(120, 20, QSizePolicy::Preferred, QSizePolicy::Minimum);

    gridLayout1->addItem(spacerItem4, 2, 3, 1, 1);

    boxSaisies = new QGroupBox(widget);
    boxSaisies->setObjectName(QString::fromUtf8("boxSaisies"));
    QSizePolicy sizePolicy5(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(1));
    sizePolicy5.setHorizontalStretch(0);
    sizePolicy5.setVerticalStretch(0);
    sizePolicy5.setHeightForWidth(boxSaisies->sizePolicy().hasHeightForWidth());
    boxSaisies->setSizePolicy(sizePolicy5);
    vboxLayout4 = new QVBoxLayout(boxSaisies);
    vboxLayout4->setSpacing(6);
    vboxLayout4->setMargin(9);
    vboxLayout4->setObjectName(QString::fromUtf8("vboxLayout4"));
    gridLayout2 = new QGridLayout();
    gridLayout2->setSpacing(3);
    gridLayout2->setMargin(0);
    gridLayout2->setObjectName(QString::fromUtf8("gridLayout2"));
    label_Ctr = new QLabel(boxSaisies);
    label_Ctr->setObjectName(QString::fromUtf8("label_Ctr"));
    label_Ctr->setTextFormat(Qt::AutoText);
    label_Ctr->setAlignment(Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter);

    gridLayout2->addWidget(label_Ctr, 1, 2, 1, 1);

    label_Var = new QLabel(boxSaisies);
    label_Var->setObjectName(QString::fromUtf8("label_Var"));
    label_Var->setAlignment(Qt::AlignLeading|Qt::AlignLeft|Qt::AlignVCenter);

    gridLayout2->addWidget(label_Var, 0, 2, 1, 1);

    spinBox_Var = new QSpinBox(boxSaisies);
    spinBox_Var->setObjectName(QString::fromUtf8("spinBox_Var"));
    QSizePolicy sizePolicy6(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(0));
    sizePolicy6.setHorizontalStretch(0);
    sizePolicy6.setVerticalStretch(0);
    sizePolicy6.setHeightForWidth(spinBox_Var->sizePolicy().hasHeightForWidth());
    spinBox_Var->setSizePolicy(sizePolicy6);
    spinBox_Var->setMinimumSize(QSize(50, 24));
    spinBox_Var->setMaximum(999);
    spinBox_Var->setMinimum(1);
    spinBox_Var->setValue(1);

    gridLayout2->addWidget(spinBox_Var, 0, 0, 1, 1);

    spinBox_Ctr = new QSpinBox(boxSaisies);
    spinBox_Ctr->setObjectName(QString::fromUtf8("spinBox_Ctr"));
    QSizePolicy sizePolicy7(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(0));
    sizePolicy7.setHorizontalStretch(0);
    sizePolicy7.setVerticalStretch(0);
    sizePolicy7.setHeightForWidth(spinBox_Ctr->sizePolicy().hasHeightForWidth());
    spinBox_Ctr->setSizePolicy(sizePolicy7);
    spinBox_Ctr->setMinimumSize(QSize(50, 24));
    spinBox_Ctr->setMaximum(999);
    spinBox_Ctr->setMinimum(1);
    spinBox_Ctr->setValue(1);

    gridLayout2->addWidget(spinBox_Ctr, 1, 0, 1, 1);

    spacerItem5 = new QSpacerItem(10, 20, QSizePolicy::Fixed, QSizePolicy::Minimum);

    gridLayout2->addItem(spacerItem5, 0, 1, 2, 1);


    vboxLayout4->addLayout(gridLayout2);

    buttonVar = new QPushButton(boxSaisies);
    buttonVar->setObjectName(QString::fromUtf8("buttonVar"));
    QSizePolicy sizePolicy8(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(0));
    sizePolicy8.setHorizontalStretch(0);
    sizePolicy8.setVerticalStretch(0);
    sizePolicy8.setHeightForWidth(buttonVar->sizePolicy().hasHeightForWidth());
    buttonVar->setSizePolicy(sizePolicy8);
    buttonVar->setMinimumSize(QSize(140, 35));

    vboxLayout4->addWidget(buttonVar);

    buttonCtr = new QPushButton(boxSaisies);
    buttonCtr->setObjectName(QString::fromUtf8("buttonCtr"));
    QSizePolicy sizePolicy9(static_cast<QSizePolicy::Policy>(0), static_cast<QSizePolicy::Policy>(0));
    sizePolicy9.setHorizontalStretch(0);
    sizePolicy9.setVerticalStretch(0);
    sizePolicy9.setHeightForWidth(buttonCtr->sizePolicy().hasHeightForWidth());
    buttonCtr->setSizePolicy(sizePolicy9);
    buttonCtr->setMinimumSize(QSize(140, 35));

    vboxLayout4->addWidget(buttonCtr);


    gridLayout1->addWidget(boxSaisies, 0, 0, 3, 1);

    splitter->addWidget(widget);

    vboxLayout->addWidget(splitter);

    MainWindow->setCentralWidget(centralwidget);
    menubar = new QMenuBar(MainWindow);
    menubar->setObjectName(QString::fromUtf8("menubar"));
    menubar->setGeometry(QRect(0, 0, 800, 21));
    menu = new QMenu(menubar);
    menu->setObjectName(QString::fromUtf8("menu"));
    menuFichier = new QMenu(menubar);
    menuFichier->setObjectName(QString::fromUtf8("menuFichier"));
    menuEdition = new QMenu(menubar);
    menuEdition->setObjectName(QString::fromUtf8("menuEdition"));
    menuAfficher = new QMenu(menubar);
    menuAfficher->setObjectName(QString::fromUtf8("menuAfficher"));
    MainWindow->setMenuBar(menubar);
    statusbar = new QStatusBar(MainWindow);
    statusbar->setObjectName(QString::fromUtf8("statusbar"));
    MainWindow->setStatusBar(statusbar);

    menubar->addAction(menuFichier->menuAction());
    menubar->addAction(menuEdition->menuAction());
    menubar->addAction(menuAfficher->menuAction());
    menubar->addAction(menu->menuAction());
    menu->addAction(actionReadme);
    menu->addSeparator();
    menu->addAction(actionAPropos);
    menuFichier->addAction(actionNouveau);
    menuFichier->addSeparator();
    menuFichier->addAction(actionExporter);
    menuFichier->addAction(actionImporter);
    menuFichier->addSeparator();
    menuFichier->addAction(actionQuitter);
    menuEdition->addAction(actionNomVar);
    menuEdition->addAction(actionNomCtr);
    menuAfficher->addAction(actionTout);
    menuAfficher->addSeparator();
    menuAfficher->addAction(actionSaisies);
    menuAfficher->addAction(actionMini_Menu);
    menuAfficher->addAction(actionLog);
    retranslateUi(MainWindow);

    ongletsMatrices->setCurrentIndex(0);


    QMetaObject::connectSlotsByName(MainWindow);
    } // setupUi

    void retranslateUi(QMainWindow *MainWindow)
    {
    MainWindow->setWindowTitle(QApplication::translate("MainWindow", " ProgLineaireGUI", 0, QApplication::UnicodeUTF8));
    actionNouveau->setText(QApplication::translate("MainWindow", "Nouveau", 0, QApplication::UnicodeUTF8));
    actionNouveau->setShortcut(QApplication::translate("MainWindow", "Ctrl+N", 0, QApplication::UnicodeUTF8));
    actionQuitter->setText(QApplication::translate("MainWindow", "Quitter", 0, QApplication::UnicodeUTF8));
    actionQuitter->setShortcut(QApplication::translate("MainWindow", "Esc", 0, QApplication::UnicodeUTF8));
    actionExporter->setText(QApplication::translate("MainWindow", "Exporter...", 0, QApplication::UnicodeUTF8));
    actionExporter->setShortcut(QApplication::translate("MainWindow", "Ctrl+E", 0, QApplication::UnicodeUTF8));
    actionImporter->setText(QApplication::translate("MainWindow", "Importer...", 0, QApplication::UnicodeUTF8));
    actionImporter->setShortcut(QApplication::translate("MainWindow", "Ctrl+I", 0, QApplication::UnicodeUTF8));
    actionAPropos->setText(QApplication::translate("MainWindow", "A propos de ProgLineaireGUI", 0, QApplication::UnicodeUTF8));
    actionAPropos->setShortcut(QApplication::translate("MainWindow", "", 0, QApplication::UnicodeUTF8));
    actionLog->setText(QApplication::translate("MainWindow", "Log", 0, QApplication::UnicodeUTF8));
    actionLog->setShortcut(QApplication::translate("MainWindow", "Ctrl+L", 0, QApplication::UnicodeUTF8));
    actionNomVar->setText(QApplication::translate("MainWindow", "Nommer les variables", 0, QApplication::UnicodeUTF8));
    actionNomCtr->setText(QApplication::translate("MainWindow", "Nommer les contraintes", 0, QApplication::UnicodeUTF8));
    actionReadme->setText(QApplication::translate("MainWindow", "Voir le fichier Readme", 0, QApplication::UnicodeUTF8));
    actionExcel->setText(QApplication::translate("MainWindow", "Voir la matrice dans Excel", 0, QApplication::UnicodeUTF8));
    actionSaisies->setText(QApplication::translate("MainWindow", "Saisies", 0, QApplication::UnicodeUTF8));
    actionSaisies->setShortcut(QApplication::translate("MainWindow", "Ctrl+S", 0, QApplication::UnicodeUTF8));
    actionMini_Menu->setText(QApplication::translate("MainWindow", "Mini Menu", 0, QApplication::UnicodeUTF8));
    actionMini_Menu->setShortcut(QApplication::translate("MainWindow", "Ctrl+M", 0, QApplication::UnicodeUTF8));
    actionTout->setText(QApplication::translate("MainWindow", "Tout", 0, QApplication::UnicodeUTF8));
    actionTout->setShortcut(QApplication::translate("MainWindow", "Ctrl+T", 0, QApplication::UnicodeUTF8));
    ongletsMatrices->setStatusTip(QApplication::translate("MainWindow", "Choix des diff\303\251rentes \303\251tapes du calcul", 0, QApplication::UnicodeUTF8));
    Matrice->clear();
    Matrice->setColumnCount(0);
    Matrice->setRowCount(0);
    Matrice->setStatusTip(QApplication::translate("MainWindow", "Cliquez pour modifiez la matrice", 0, QApplication::UnicodeUTF8));
    ongletsMatrices->setTabText(ongletsMatrices->indexOf(tab_init), QApplication::translate("MainWindow", "Matrice initiale", 0, QApplication::UnicodeUTF8));
    boxMini_Menu->setTitle(QApplication::translate("MainWindow", "Mini Menu", 0, QApplication::UnicodeUTF8));
    buttonNouveau->setStatusTip(QApplication::translate("MainWindow", "Cr\303\251er une nouvelle matrice", 0, QApplication::UnicodeUTF8));
    buttonNouveau->setText(QApplication::translate("MainWindow", "Nouveau", 0, QApplication::UnicodeUTF8));
    buttonExporter->setStatusTip(QApplication::translate("MainWindow", "Exporter la matrice initiale au format excel ou texte", 0, QApplication::UnicodeUTF8));
    buttonExporter->setText(QApplication::translate("MainWindow", "Exporter...", 0, QApplication::UnicodeUTF8));
    buttonImporter->setStatusTip(QApplication::translate("MainWindow", "Importer une matrice au format excel ou texte", 0, QApplication::UnicodeUTF8));
    buttonImporter->setText(QApplication::translate("MainWindow", "Importer...", 0, QApplication::UnicodeUTF8));
    buttonRes->setStatusTip(QApplication::translate("MainWindow", "Lancer les it\303\251rations de r\303\251solution", 0, QApplication::UnicodeUTF8));
    buttonRes->setText(QApplication::translate("MainWindow", "R\303\251soudre le probl\303\250me", 0, QApplication::UnicodeUTF8));
    radioButton_Primal->setStatusTip(QApplication::translate("MainWindow", "R\303\251soudre le probl\303\250me en primal", 0, QApplication::UnicodeUTF8));
    radioButton_Primal->setText(QApplication::translate("MainWindow", "Primal", 0, QApplication::UnicodeUTF8));
    radioButton_Dual->setStatusTip(QApplication::translate("MainWindow", "Fonction pas encore g\303\251r\303\251e par le programme...", 0, QApplication::UnicodeUTF8));
    radioButton_Dual->setText(QApplication::translate("MainWindow", "Dual", 0, QApplication::UnicodeUTF8));
    boxLog->setTitle(QApplication::translate("MainWindow", "Log", 0, QApplication::UnicodeUTF8));
    textLog->setStatusTip(QApplication::translate("MainWindow", "Historique des actions effectu\303\251es", 0, QApplication::UnicodeUTF8));
    boxSaisies->setTitle(QApplication::translate("MainWindow", "Saisies", 0, QApplication::UnicodeUTF8));
    label_Ctr->setText(QApplication::translate("MainWindow", "Contrainte(s)", 0, QApplication::UnicodeUTF8));
    label_Var->setText(QApplication::translate("MainWindow", "Variable(s)", 0, QApplication::UnicodeUTF8));
    spinBox_Var->setStatusTip(QApplication::translate("MainWindow", "Choisissez un nombre de variables pour votre syst\303\250me", 0, QApplication::UnicodeUTF8));
    spinBox_Ctr->setStatusTip(QApplication::translate("MainWindow", "Choisissez un nombre de contraintes pour votre syst\303\250me", 0, QApplication::UnicodeUTF8));
    buttonVar->setStatusTip(QApplication::translate("MainWindow", "Donner un libell\303\251 \303\240 vos variables", 0, QApplication::UnicodeUTF8));
    buttonVar->setText(QApplication::translate("MainWindow", "Nommer les variables", 0, QApplication::UnicodeUTF8));
    buttonCtr->setStatusTip(QApplication::translate("MainWindow", "Donner un libell\303\251 \303\240 vos contraintes", 0, QApplication::UnicodeUTF8));
    buttonCtr->setText(QApplication::translate("MainWindow", "Nommer les contraintes", 0, QApplication::UnicodeUTF8));
    menu->setTitle(QApplication::translate("MainWindow", "?", 0, QApplication::UnicodeUTF8));
    menuFichier->setTitle(QApplication::translate("MainWindow", "Fichier", 0, QApplication::UnicodeUTF8));
    menuEdition->setTitle(QApplication::translate("MainWindow", "Edition", 0, QApplication::UnicodeUTF8));
    menuAfficher->setTitle(QApplication::translate("MainWindow", "Afficher", 0, QApplication::UnicodeUTF8));
    } // retranslateUi

};

namespace Ui {
    class MainWindow: public Ui_MainWindow {};
} // namespace Ui

#endif // UI_INTERFACE_H
